;; Problem 29
;; 25 October 2002

;; Consider all integer combinations of ab for 2 <= a <= 5 and 2 <= b <= 5:

;;     22=4, 23=8, 24=16, 25=32
;;     32=9, 33=27, 34=81, 35=243
;;     42=16, 43=64, 44=256, 45=1024
;;     52=25, 53=125, 54=625, 55=3125

;; If they are then placed in numerical order, with any repeats removed, we get the following sequence of 15 distinct terms:

;; 4, 8, 9, 16, 25, 27, 32, 64, 81, 125, 243, 256, 625, 1024, 3125

;; How many distinct terms are in the sequence generated by ab for 2 <= a <= 100 and 2 <= b <= 100?

(defmacro acollect (&body body)
  (let ((resv (gensym)))
    `(let ((it (list))
	   (,resv nil))
      (setf ,resv (progn ,@body))
      (values it ,resv))))

(defun gen-pairings ()
  (acollect
    (loop for aa from 2 to 100
	  do
	  (loop for bb from 2 to 100
		do
		(push (expt aa bb) it)))))

(defun list-unique (things)
  (let ((ht (make-hash-table))
	(result (list)))
    (loop for thing in things
	  do
	  (when (not (gethash thing ht))
	    (setf (gethash thing ht) t)
	    (push thing result)))
    (reverse result)))

(length (list-unique (gen-pairings))) ; 9183